<template>
  <div
    class="user-chat-card"
    :class="size"
  >
    <div class="user-avatar">
      <UserProfileMenu
        :user="user"
        :parent-menu-id="parentMenuId"
        :avatar-size="avatarSize"
        :hide-status="hideStatus"
      >
        <UserProfile :user="user" />
      </UserProfileMenu>
    </div>
    <JText
      :type="size === 'small' ? 'text-2' : 'text-1'"
      color="secondary-title"
      weight="normal"
    >
      {{ user.name }}
    </JText>
  </div>
</template>

<script setup lang="ts">
import { computed, PropType } from 'vue';
import { JText } from '@new-jira-clone/ui/src/components';
import { IUser } from '@/shared';
import { UserProfile, UserProfileMenu } from '@/features/user-profile';

const props = defineProps({
  parentMenuId: {
    type: Number,
    default: null,
  },
  user: {
    type: Object as PropType<IUser>,
    required: true,
  },
  size: {
    type: String,
    default: 'normal',
    validator: (value: string): boolean => ['small', 'normal'].includes(value),
  },
  hideStatus: {
    type: Boolean,
    default: false,
  },
});

const avatarSize = computed(() => {
  if (props.size === 'small') {
    return 'xs';
  }

  return 's';
});
</script>

<style lang="scss" scoped>
.user-chat-card {
  display: flex;
  align-items: center;

  &.normal {
    .user-avatar {
      margin-right: 12px;
    }
  }

  &.small {
    .user-avatar {
      margin-right: 6px;
    }
  }
}
</style>
